From 7d29fea0fcf8e6aec2877804555dd0239fdaf1be Mon Sep 17 00:00:00 2001
From: amitlan <amitlangote09@gmail.com>
Date: Wed, 22 Dec 2021 16:55:17 +0900
Subject: [PATCH v4] Invent a new executor "prep" phase

The new phase, implemented by execMain.c:ExecutorPrep() and its
recursive underling execProcnode.c:ExecPrepNode(), takes a query's
PlannedStmt and processes the plan tree contained in it to produce
a ExecPrepOutput node as result.

As the plan tree is walked, each node must add the RT index(es) of
any relation(s) that it directly manipulates to a bitmapset member of
ExecPrepOutput (for example, an IndexScan node must add the Scan's
scanrelid).  Also, each node may want to make a PlanPrepOutput node
containing additional information that may be of interest to the
calling module or to the later execution phases, if the node can
provide one (for example, an Append node may perform initial pruning
and add a set of "initially valid subplans" to the PlanPrepOutput).
The PlanPrepOutput nodess of all the plan nodes are added to an array
in the ExecPrepOutput, which is indexed using the individual nodes'
plan_node_id; a NULL is stored in the array slots of nodes that
don't have anything interesting to add to the PlanPrepOutput.

The ExecPrepOutput thus produced is passed to CreateQueryDesc()
and subsequently to ExecutorStart() via QueryDesc, which then makes
it available to the executor routines via the query's EState.

The main goal of adding this new phase is, for now, to allow cached
cached generic plans containing scans of partitioned tables using
Append/MergeAppend to be executed more efficiently by the prep phase
doing any initial pruning, instead of deferring that to
ExecutorStart().  That may allow AcquireExecutorLocks() on the plan
to lock only only the minimal set of relations/partitions, that is
those whose subplans survive the initial pruning.

Implementation notes:

* To allow initial pruning to be done as part of the pre-execution
prep phase as opposed to as part of ExecutorStart(), this refactors
ExecCreatePartitionPruneState() and ExecFindInitialMatchingSubPlans()
to pass the information needed to do initial pruning directly as
parameters instead of getting that from the EState and the PlanState
of the parent Append/MergeAppend, both of which would not be
available in ExecutorPrep().  Another, sort of non-essential-to-this-
goal, refactoring this does is moving the partition pruning
initialization stanzas in ExecInitAppend() and ExecInitMergeAppend()
both of which contain the same cod into its own function
ExecInitPartitionPruning().

* To pass the ExecPrepOutput(s) created by the plancache module's
invocation of ExecutorPrep() to the callers of the module, which in
turn would pass them down to ExecutorStart(), CachedPlan gets a new
List field that stores those ExecPrepOutputs, containing one element
for each PlannedStmt also contained in the CachedPlan.  The new list
is stored in a child context of the context containing the
PlannedStmts, though unlike the latter, it is reset on every
invocation of CheckCachedPlan(), which in turn calls ExecutorPrep()
with a new set of bound Params.

* AcquireExecutorLocks() is now made to loop over a bitmapset of RT
indexes, those of relations returned in ExecPrepOutput, instead of
over the whole range table.  With initial pruning that is also done
as part of ExcecutorPrep(), only relations from non-pruned nodes of
the plan tree would get locked as a result of this new arrangement.

* PlannedStmt gets a new field usesPrepExecPruning that indicates
whether any of the nodes of the plan tree contain "initial" (or
"pre-execution") pruning steps, which saves ExecutorPrep() the
trouble of walking the plan tree only to find out whether that's
the case.

* PartitionPruneInfo nodes now explicitly stores whether the steps
contained in any of the individual PartitionedRelPruneInfos embedded
in it contain initial pruning steps (those that can be performed
during ExecutorPrep) and execution pruning steps (those that can only
be performed during ExecutorRun), as flags contains_initial_steps and
contains_exec_steps, respectively.  In fact, the aforementioned
PlannedStmt field's value is a logical OR of the values of the former
across all PartitionPruneInfo nodes embedded in the plan tree.

* PlannedStmt also gets a bitmapset field to store the RT indexes of
all relation RTEs referenced in the query that is populated when
contructing the flat range table in setrefs.c, which effectively
contains all the relations that the planner must have locked. In the
case of a cached plan, AcquireExecutorLocks() must lock all of those
relations, except those whose subnodes get pruned as result of
ExecutorPrep().

* PlannedStmt gets yet another field numPlanNodes that records the
highest plan_node_id assigned to any of the node contained in the
tree, which serves as the size to use when allocating the
PlanPrepOutput array.
---
 src/backend/commands/copyto.c                 |   2 +-
 src/backend/commands/createas.c               |   2 +-
 src/backend/commands/explain.c                |   7 +-
 src/backend/commands/extension.c              |  13 +-
 src/backend/commands/matview.c                |   2 +-
 src/backend/commands/portalcmds.c             |   1 +
 src/backend/commands/prepare.c                |  17 +-
 src/backend/executor/README                   |  18 +
 src/backend/executor/execMain.c               |  48 ++
 src/backend/executor/execParallel.c           |   4 +-
 src/backend/executor/execPartition.c          | 538 +++++++++++++-----
 src/backend/executor/execProcnode.c           | 206 +++++++
 src/backend/executor/execUtils.c              |   8 +
 src/backend/executor/functions.c              |   2 +-
 src/backend/executor/nodeAgg.c                |  13 +
 src/backend/executor/nodeAppend.c             |  91 ++-
 src/backend/executor/nodeBitmapAnd.c          |  18 +
 src/backend/executor/nodeBitmapHeapscan.c     |  14 +
 src/backend/executor/nodeBitmapIndexscan.c    |  14 +
 src/backend/executor/nodeBitmapOr.c           |  18 +
 src/backend/executor/nodeCtescan.c            |  12 +
 src/backend/executor/nodeCustom.c             |  18 +
 src/backend/executor/nodeForeignscan.c        |  12 +
 src/backend/executor/nodeFunctionscan.c       |  13 +
 src/backend/executor/nodeGather.c             |  13 +
 src/backend/executor/nodeGatherMerge.c        |  13 +
 src/backend/executor/nodeGroup.c              |  13 +
 src/backend/executor/nodeHash.c               |  13 +
 src/backend/executor/nodeHashjoin.c           |  14 +
 src/backend/executor/nodeIncrementalSort.c    |  14 +
 src/backend/executor/nodeIndexonlyscan.c      |  14 +
 src/backend/executor/nodeIndexscan.c          |  14 +
 src/backend/executor/nodeLimit.c              |  13 +
 src/backend/executor/nodeLockRows.c           |  13 +
 src/backend/executor/nodeMaterial.c           |  13 +
 src/backend/executor/nodeMemoize.c            |  13 +
 src/backend/executor/nodeMergeAppend.c        |  90 ++-
 src/backend/executor/nodeMergejoin.c          |  14 +
 src/backend/executor/nodeModifyTable.c        |  26 +
 .../executor/nodeNamedtuplestorescan.c        |  13 +
 src/backend/executor/nodeNestloop.c           |  14 +
 src/backend/executor/nodeProjectSet.c         |  13 +
 src/backend/executor/nodeRecursiveunion.c     |  14 +
 src/backend/executor/nodeResult.c             |  13 +
 src/backend/executor/nodeSamplescan.c         |  14 +
 src/backend/executor/nodeSeqscan.c            |  13 +
 src/backend/executor/nodeSetOp.c              |  13 +
 src/backend/executor/nodeSort.c               |  13 +
 src/backend/executor/nodeSubplan.c            |  12 +
 src/backend/executor/nodeSubqueryscan.c       |  14 +
 src/backend/executor/nodeTableFuncscan.c      |  13 +
 src/backend/executor/nodeTidrangescan.c       |  14 +
 src/backend/executor/nodeTidscan.c            |  15 +-
 src/backend/executor/nodeUnique.c             |  13 +
 src/backend/executor/nodeValuesscan.c         |  13 +
 src/backend/executor/nodeWindowAgg.c          |  13 +
 src/backend/executor/nodeWorktablescan.c      |  12 +
 src/backend/executor/spi.c                    |  14 +-
 src/backend/nodes/copyfuncs.c                 |  49 ++
 src/backend/nodes/outfuncs.c                  |   6 +
 src/backend/nodes/readfuncs.c                 |   5 +
 src/backend/optimizer/plan/planner.c          |   3 +
 src/backend/optimizer/plan/setrefs.c          |  10 +
 src/backend/partitioning/partprune.c          |  57 +-
 src/backend/tcop/postgres.c                   |  15 +-
 src/backend/tcop/pquery.c                     |  21 +-
 src/backend/utils/cache/plancache.c           | 155 +++--
 src/backend/utils/mmgr/portalmem.c            |   2 +
 src/include/commands/explain.h                |   3 +-
 src/include/executor/execPartition.h          |  19 +-
 src/include/executor/execdesc.h               |   2 +
 src/include/executor/executor.h               |   3 +
 src/include/executor/nodeAgg.h                |   1 +
 src/include/executor/nodeAppend.h             |   1 +
 src/include/executor/nodeBitmapAnd.h          |   1 +
 src/include/executor/nodeBitmapHeapscan.h     |   1 +
 src/include/executor/nodeBitmapIndexscan.h    |   1 +
 src/include/executor/nodeBitmapOr.h           |   1 +
 src/include/executor/nodeCtescan.h            |   1 +
 src/include/executor/nodeCustom.h             |   1 +
 src/include/executor/nodeForeignscan.h        |   1 +
 src/include/executor/nodeFunctionscan.h       |   1 +
 src/include/executor/nodeGather.h             |   1 +
 src/include/executor/nodeGatherMerge.h        |   1 +
 src/include/executor/nodeGroup.h              |   1 +
 src/include/executor/nodeHash.h               |   1 +
 src/include/executor/nodeHashjoin.h           |   1 +
 src/include/executor/nodeIncrementalSort.h    |   1 +
 src/include/executor/nodeIndexonlyscan.h      |   1 +
 src/include/executor/nodeIndexscan.h          |   1 +
 src/include/executor/nodeLimit.h              |   1 +
 src/include/executor/nodeLockRows.h           |   1 +
 src/include/executor/nodeMaterial.h           |   1 +
 src/include/executor/nodeMemoize.h            |   1 +
 src/include/executor/nodeMergeAppend.h        |   1 +
 src/include/executor/nodeMergejoin.h          |   1 +
 src/include/executor/nodeModifyTable.h        |   1 +
 .../executor/nodeNamedtuplestorescan.h        |   1 +
 src/include/executor/nodeNestloop.h           |   1 +
 src/include/executor/nodeProjectSet.h         |   1 +
 src/include/executor/nodeRecursiveunion.h     |   1 +
 src/include/executor/nodeResult.h             |   2 +
 src/include/executor/nodeSamplescan.h         |   1 +
 src/include/executor/nodeSeqscan.h            |   1 +
 src/include/executor/nodeSetOp.h              |   1 +
 src/include/executor/nodeSort.h               |   1 +
 src/include/executor/nodeSubplan.h            |   1 +
 src/include/executor/nodeSubqueryscan.h       |   1 +
 src/include/executor/nodeTableFuncscan.h      |   1 +
 src/include/executor/nodeTidrangescan.h       |   1 +
 src/include/executor/nodeTidscan.h            |   1 +
 src/include/executor/nodeUnique.h             |   1 +
 src/include/executor/nodeValuesscan.h         |   1 +
 src/include/executor/nodeWindowAgg.h          |   1 +
 src/include/executor/nodeWorktablescan.h      |   1 +
 src/include/nodes/execnodes.h                 |  78 +++
 src/include/nodes/nodeFuncs.h                 |   3 +
 src/include/nodes/nodes.h                     |   5 +
 src/include/nodes/pathnodes.h                 |   6 +
 src/include/nodes/plannodes.h                 |  17 +
 src/include/partitioning/partprune.h          |   2 +
 src/include/tcop/tcopprot.h                   |   2 +-
 src/include/utils/plancache.h                 |   5 +
 src/include/utils/portal.h                    |   5 +
 124 files changed, 1866 insertions(+), 285 deletions(-)

diff --git a/src/backend/commands/copyto.c b/src/backend/commands/copyto.c
index 3283ef50d0..bb7d5e65ea 100644
--- a/src/backend/commands/copyto.c
+++ b/src/backend/commands/copyto.c
@@ -542,7 +542,7 @@ BeginCopyTo(ParseState *pstate,
 		((DR_copy *) dest)->cstate = cstate;
 
 		/* Create a QueryDesc requesting no output */
-		cstate->queryDesc = CreateQueryDesc(plan, pstate->p_sourcetext,
+		cstate->queryDesc = CreateQueryDesc(plan, NULL, pstate->p_sourcetext,
 											GetActiveSnapshot(),
 											InvalidSnapshot,
 											dest, NULL, NULL, 0);
diff --git a/src/backend/commands/createas.c b/src/backend/commands/createas.c
index 9abbb6b555..f6607f2454 100644
--- a/src/backend/commands/createas.c
+++ b/src/backend/commands/createas.c
@@ -325,7 +325,7 @@ ExecCreateTableAs(ParseState *pstate, CreateTableAsStmt *stmt,
 		UpdateActiveSnapshotCommandId();
 
 		/* Create a QueryDesc, redirecting output to our tuple receiver */
-		queryDesc = CreateQueryDesc(plan, pstate->p_sourcetext,
+		queryDesc = CreateQueryDesc(plan, NULL, pstate->p_sourcetext,
 									GetActiveSnapshot(), InvalidSnapshot,
 									dest, params, queryEnv, 0);
 
diff --git a/src/backend/commands/explain.c b/src/backend/commands/explain.c
index b970997c34..9ee82824a1 100644
--- a/src/backend/commands/explain.c
+++ b/src/backend/commands/explain.c
@@ -407,7 +407,7 @@ ExplainOneQuery(Query *query, int cursorOptions,
 		}
 
 		/* run it (if needed) and produce output */
-		ExplainOnePlan(plan, into, es, queryString, params, queryEnv,
+		ExplainOnePlan(plan, NULL, into, es, queryString, params, queryEnv,
 					   &planduration, (es->buffers ? &bufusage : NULL));
 	}
 }
@@ -515,7 +515,8 @@ ExplainOneUtility(Node *utilityStmt, IntoClause *into, ExplainState *es,
  * to call it.
  */
 void
-ExplainOnePlan(PlannedStmt *plannedstmt, IntoClause *into, ExplainState *es,
+ExplainOnePlan(PlannedStmt *plannedstmt, ExecPrepOutput *execprep,
+			   IntoClause *into, ExplainState *es,
 			   const char *queryString, ParamListInfo params,
 			   QueryEnvironment *queryEnv, const instr_time *planduration,
 			   const BufferUsage *bufusage)
@@ -563,7 +564,7 @@ ExplainOnePlan(PlannedStmt *plannedstmt, IntoClause *into, ExplainState *es,
 		dest = None_Receiver;
 
 	/* Create a QueryDesc for the query */
-	queryDesc = CreateQueryDesc(plannedstmt, queryString,
+	queryDesc = CreateQueryDesc(plannedstmt, execprep, queryString,
 								GetActiveSnapshot(), InvalidSnapshot,
 								dest, params, queryEnv, instrument_option);
 
diff --git a/src/backend/commands/extension.c b/src/backend/commands/extension.c
index a2e77c418a..214a345aa2 100644
--- a/src/backend/commands/extension.c
+++ b/src/backend/commands/extension.c
@@ -741,8 +741,10 @@ execute_sql_string(const char *sql)
 		RawStmt    *parsetree = lfirst_node(RawStmt, lc1);
 		MemoryContext per_parsetree_context,
 					oldcontext;
-		List	   *stmt_list;
-		ListCell   *lc2;
+		List	   *stmt_list,
+				   *stmt_execprep_list;
+		ListCell   *lc2,
+				   *lc3;
 
 		/*
 		 * We do the work for each parsetree in a short-lived context, to
@@ -762,11 +764,13 @@ execute_sql_string(const char *sql)
 										   NULL,
 										   0,
 										   NULL);
-		stmt_list = pg_plan_queries(stmt_list, sql, CURSOR_OPT_PARALLEL_OK, NULL);
+		stmt_list = pg_plan_queries(stmt_list, sql, CURSOR_OPT_PARALLEL_OK, NULL,
+									&stmt_execprep_list);
 
-		foreach(lc2, stmt_list)
+		forboth(lc2, stmt_list, lc3, stmt_execprep_list)
 		{
 			PlannedStmt *stmt = lfirst_node(PlannedStmt, lc2);
+			ExecPrepOutput *execprep = lfirst_node(ExecPrepOutput, lc3);
 
 			CommandCounterIncrement();
 
@@ -777,6 +781,7 @@ execute_sql_string(const char *sql)
 				QueryDesc  *qdesc;
 
 				qdesc = CreateQueryDesc(stmt,
+										execprep,
 										sql,
 										GetActiveSnapshot(), NULL,
 										dest, NULL, NULL, 0);
diff --git a/src/backend/commands/matview.c b/src/backend/commands/matview.c
index 05e7b60059..4ef44aaf23 100644
--- a/src/backend/commands/matview.c
+++ b/src/backend/commands/matview.c
@@ -416,7 +416,7 @@ refresh_matview_datafill(DestReceiver *dest, Query *query,
 	UpdateActiveSnapshotCommandId();
 
 	/* Create a QueryDesc, redirecting output to our tuple receiver */
-	queryDesc = CreateQueryDesc(plan, queryString,
+	queryDesc = CreateQueryDesc(plan, NULL, queryString,
 								GetActiveSnapshot(), InvalidSnapshot,
 								dest, NULL, NULL, 0);
 
diff --git a/src/backend/commands/portalcmds.c b/src/backend/commands/portalcmds.c
index 9902c5c566..0bea2dd18f 100644
--- a/src/backend/commands/portalcmds.c
+++ b/src/backend/commands/portalcmds.c
@@ -107,6 +107,7 @@ PerformCursorOpen(ParseState *pstate, DeclareCursorStmt *cstmt, ParamListInfo pa
 					  queryString,
 					  CMDTAG_SELECT,	/* cursor's query is always a SELECT */
 					  list_make1(plan),
+					  list_make1(NULL),	/* no ExecPrepOutput to pass */
 					  NULL);
 
 	/*----------
diff --git a/src/backend/commands/prepare.c b/src/backend/commands/prepare.c
index 206d2bbbf9..ac188a7347 100644
--- a/src/backend/commands/prepare.c
+++ b/src/backend/commands/prepare.c
@@ -189,6 +189,7 @@ ExecuteQuery(ParseState *pstate,
 	PreparedStatement *entry;
 	CachedPlan *cplan;
 	List	   *plan_list;
+	List	   *plan_execprep_list;
 	ParamListInfo paramLI = NULL;
 	EState	   *estate = NULL;
 	Portal		portal;
@@ -229,6 +230,7 @@ ExecuteQuery(ParseState *pstate,
 	/* Replan if needed, and increment plan refcount for portal */
 	cplan = GetCachedPlan(entry->plansource, paramLI, NULL, NULL);
 	plan_list = cplan->stmt_list;
+	plan_execprep_list = cplan->stmt_execprep_list;
 
 	/*
 	 * DO NOT add any logic that could possibly throw an error between
@@ -238,7 +240,7 @@ ExecuteQuery(ParseState *pstate,
 					  NULL,
 					  query_string,
 					  entry->plansource->commandTag,
-					  plan_list,
+					  plan_list, plan_execprep_list,
 					  cplan);
 
 	/*
@@ -610,7 +612,9 @@ ExplainExecuteQuery(ExecuteStmt *execstmt, IntoClause *into, ExplainState *es,
 	const char *query_string;
 	CachedPlan *cplan;
 	List	   *plan_list;
-	ListCell   *p;
+	List	   *plan_execprep_list;
+	ListCell   *p,
+			   *pe;
 	ParamListInfo paramLI = NULL;
 	EState	   *estate = NULL;
 	instr_time	planstart;
@@ -666,15 +670,18 @@ ExplainExecuteQuery(ExecuteStmt *execstmt, IntoClause *into, ExplainState *es,
 	}
 
 	plan_list = cplan->stmt_list;
+	plan_execprep_list = cplan->stmt_execprep_list;
 
 	/* Explain each query */
-	foreach(p, plan_list)
+	forboth(p, plan_list, pe, plan_execprep_list)
 	{
 		PlannedStmt *pstmt = lfirst_node(PlannedStmt, p);
+		ExecPrepOutput *execprep = lfirst_node(ExecPrepOutput, pe);
 
 		if (pstmt->commandType != CMD_UTILITY)
-			ExplainOnePlan(pstmt, into, es, query_string, paramLI, queryEnv,
-						   &planduration, (es->buffers ? &bufusage : NULL));
+			ExplainOnePlan(pstmt, execprep, into, es, query_string, paramLI,
+						   queryEnv, &planduration,
+						   (es->buffers ? &bufusage : NULL));
 		else
 			ExplainOneUtility(pstmt->utilityStmt, into, es, query_string,
 							  paramLI, queryEnv);
diff --git a/src/backend/executor/README b/src/backend/executor/README
index bf5e70860d..c25db66ff0 100644
--- a/src/backend/executor/README
+++ b/src/backend/executor/README
@@ -65,6 +65,21 @@ found there.  This currently only occurs for Append and MergeAppend nodes.  In
 this case the non-required subplans are ignored and the executor state's
 subnode array will become out of sequence to the plan's subplan list.
 
+A plan tree may also be made to go through ExecutorPrep() to collect some
+information about the individual plan nodes that may help optimize the
+actual execution of the plan.  Such information about each plan node is put
+into a PlanPrepOutput node if the plan node type supports producing one and
+stored in an array in ExecPrepOutput that in turn represents the output of
+a ExecutorPrep() run.  The PlanPrepOutput array is indexed with plan_node_id
+of the individual plan nodes.  An example of what such information may look
+like is in the "prep" routine of the Append node (ExecPrepAppend), which does
+partition pruning using "initial steps", that is, pruning with expressions
+that can evaluated even before the actual execution has started. That produces
+a set of "initially valid subplans" that is put into the PlanPrepOutput
+belonging to Append that can be used as-is by the initializer routine of the
+Append node (nodeAppend.c: ExecInitAppend) to only initialize the plan state
+trees of those subplans.
+
 Each Plan node may have expression trees associated with it, to represent
 its target list, qualification conditions, etc.  These trees are also
 read-only to the executor, but the executor state for expression evaluation
@@ -247,6 +262,9 @@ Query Processing Control Flow
 
 This is a sketch of control flow for full query processing:
 
+  [ ExecutorPrep ] --- an optional step to walk over the plan tree to produce
+		an ExecPrepOutput to be passed to CreateQueryDesc
+
 	CreateQueryDesc
 
 	ExecutorStart
diff --git a/src/backend/executor/execMain.c b/src/backend/executor/execMain.c
index 549d9eb696..e38966295e 100644
--- a/src/backend/executor/execMain.c
+++ b/src/backend/executor/execMain.c
@@ -103,6 +103,52 @@ static void EvalPlanQualStart(EPQState *epqstate, Plan *planTree);
 
 /* end of local decls */
 
+/* ----------------------------------------------------------------
+ *		ExecutorPrep
+ *
+ *		This optional executor routine must be called if the PlannedStmt
+ *		indicates that some nodes in the planTree can perform preparatory
+ *		actions, such as pre-execution/initial pruning
+ *
+ * Returned information includes the set of RT indexes of relations referenced
+ * in the plan, and a PlanPrepOutput node for each node in the planTree if the
+ * node type supports producing one.
+ *
+ * This may lock relations whose information may be used to produce the
+ * PlanPrepOutput nodes. For example, a partitioned table before perusing its
+ * PartitionPruneInfo contained in an Append node to do the pruning the result
+ * of which is used to populate the Append node's PlanPrepOutput.
+ */
+ExecPrepOutput *
+ExecutorPrep(ExecPrepContext *context)
+{
+	ExecPrepOutput *result = makeNode(ExecPrepOutput);
+
+	result->numPlanNodes = context->stmt->numPlanNodes;
+	result->planPrepResults = palloc0(sizeof(PlanPrepOutput *) *
+									  result->numPlanNodes);
+	if (!context->stmt->usesPreExecPruning)
+	{
+		/* Shortcut */
+		result->relationRTIs = bms_copy(context->stmt->relationRTIs);
+	}
+	else
+	{
+		/* Go find the nodes that need any "prep" work done. */
+		ListCell *lc;
+
+		foreach(lc, context->stmt->subplans)
+		{
+			Plan *subplan = lfirst(lc);
+
+			ExecPrepNode(subplan, context, result);
+		}
+
+		ExecPrepNode(context->stmt->planTree, context, result);
+	}
+
+	return result;
+}
 
 /* ----------------------------------------------------------------
  *		ExecutorStart
@@ -804,6 +850,7 @@ InitPlan(QueryDesc *queryDesc, int eflags)
 {
 	CmdType		operation = queryDesc->operation;
 	PlannedStmt *plannedstmt = queryDesc->plannedstmt;
+	ExecPrepOutput *execprep = queryDesc->execprep;
 	Plan	   *plan = plannedstmt->planTree;
 	List	   *rangeTable = plannedstmt->rtable;
 	EState	   *estate = queryDesc->estate;
@@ -823,6 +870,7 @@ InitPlan(QueryDesc *queryDesc, int eflags)
 	ExecInitRangeTable(estate, rangeTable);
 
 	estate->es_plannedstmt = plannedstmt;
+	estate->es_execprep = execprep;
 
 	/*
 	 * Next, build the ExecRowMark array from the PlanRowMark(s), if any.
diff --git a/src/backend/executor/execParallel.c b/src/backend/executor/execParallel.c
index 5dd8ab7db2..0567534358 100644
--- a/src/backend/executor/execParallel.c
+++ b/src/backend/executor/execParallel.c
@@ -182,8 +182,10 @@ ExecSerializePlan(Plan *plan, EState *estate)
 	pstmt->transientPlan = false;
 	pstmt->dependsOnRole = false;
 	pstmt->parallelModeNeeded = false;
+	pstmt->usesPreExecPruning = false;
 	pstmt->planTree = plan;
 	pstmt->rtable = estate->es_range_table;
+	pstmt->relationRTIs = NULL;
 	pstmt->resultRelations = NIL;
 	pstmt->appendRelations = NIL;
 
@@ -1248,7 +1250,7 @@ ExecParallelGetQueryDesc(shm_toc *toc, DestReceiver *receiver,
 	paramLI = RestoreParamList(&paramspace);
 
 	/* Create a QueryDesc for the query. */
-	return CreateQueryDesc(pstmt,
+	return CreateQueryDesc(pstmt, NULL,	/* XXX pass ExecPrepOutput too? */
 						   queryString,
 						   GetActiveSnapshot(), InvalidSnapshot,
 						   receiver, paramLI, NULL, instrument_options);
